diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/test/block-ack-test-suite.cc ns-3.31/src/wifi/test/block-ack-test-suite.cc
--- ns-3.30.1/src/wifi/test/block-ack-test-suite.cc	2019-09-18 10:36:11.000000000 -0700
+++ ns-3.31/src/wifi/test/block-ack-test-suite.cc	2020-06-27 17:38:30.000000000 -0700
@@ -290,7 +290,9 @@
     }
 
   // Notify the acknowledgment of 5 packets
-  Ptr<WifiMacQueueItem> mpdu = Create<WifiMacQueueItem> (Create<Packet> (), WifiMacHeader ());
+  WifiMacHeader hdr;
+  hdr.SetType (WIFI_MAC_QOSDATA);
+  Ptr<WifiMacQueueItem> mpdu = Create<WifiMacQueueItem> (Create<Packet> (), hdr);
   uint16_t seqNumber = startingSeq;
   mpdu->GetHeader ().SetSequenceNumber (seqNumber);
   agreement.NotifyAckedMpdu (mpdu);
@@ -617,12 +619,43 @@
  *
  * \brief Test for Block Ack Policy with aggregation disabled
  *
- * This test aims to check the Block Ack policy with "legacy" 802.11, i.e., prior
- * to aggregation (802.11n). The block ack threshold is set to 2, hence a block ack
- * agreement is established when there are at least two packets in the EDCA queue.
- * Consequently, the first packet is sent with Normal Ack policy (because a BA agreement
- * has not been established yet), while all other packets are sent with Block Ack
- * policy and followed by a Block Ack Request and then a Block Ack.
+ * This test aims to check the Block Ack policy when A-MPDU aggregation is disabled.
+ * In this case, a QoS station can transmit multiple QoS data frames before requesting
+ * a Block Ack through a Block Ack Request frame. If the AC is granted a non-null TXOP
+ * limit, MPDUs can be separated by a SIFS.
+ *
+ * In this test, an HT STA sends 14 packets to an HT AP. The ack policy selector is
+ * configured so that a Block Ack is requested once 8 (= 0.125 * 64) MPDUs are sent
+ * in addition to the MPDU having the starting sequence number. The block ack threshold
+ * is set to 2, hence a block ack agreement is established when there are at least two
+ * packets in the EDCA queue.
+ *
+ * When the TXOP limit is null:
+ * - the first packet is sent with Normal Ack policy because the BA agreement has not
+ *   been established yet (there are no queued packets when the first one arrives);
+ * - packets from the 2nd to the 10th are sent with Block Ack policy (and hence
+ *   are not immediately acknowledged);
+ * - after the 10th packet, a Block Ack Request is sent, followed by a Block Ack;
+ * - the remaining 4 packets are sent with Block Ack policy (and hence
+ *   are not immediately acknowledged);
+ * - the last packet is followed by a Block Ack Request because there are no more
+ *   packets in the EDCA queue and hence a response is needed independently of
+ *   the number of outstanding MPDUs.
+ *
+ * When the TXOP is not null (and long enough to include the transmission of all packets):
+ * - the first packet is sent with Normal Ack policy because the BA agreement has not
+ *   been established yet (there are no queued packets when the first one arrives);
+ * - the second packet is sent with Normal Ack Policy because the first packet sent in
+ *   a TXOP shall request an immediate response and no previous MPDUs have to be
+ *   acknowledged;
+ * - packets from the 3rd to the 11th are sent with Block Ack policy (and hence
+ *   are not immediately acknowledged);
+ * - after the 11th packet, a Block Ack Request is sent, followed by a Block Ack;
+ * - the remaining 3 packets are sent with Block Ack policy (and hence
+ *   are not immediately acknowledged);
+ * - the last packet is followed by a Block Ack Request because there are no more
+ *   packets in the EDCA queue and hence a response is needed independently of
+ *   the number of outstanding MPDUs.
  */
 class BlockAckAggregationDisabledTest : public TestCase
 {
@@ -631,20 +664,32 @@
   */
   struct TxopDurationTracer
   {
+    /**
+     * Callback for the TxopTrace trace
+     * \param startTime TXOP start time
+     * \param duration TXOP duration
+     */
     void Trace (Time startTime, Time duration);
-    Time m_max {Seconds (0)};
+    Time m_max {Seconds (0)};  ///< max TXOP duration
   };
 
 public:
-  BlockAckAggregationDisabledTest ();
+  /**
+   * \brief Constructor
+   * \param txop true for non-null TXOP limit
+   */
+  BlockAckAggregationDisabledTest (bool txop);
   virtual ~BlockAckAggregationDisabledTest ();
 
   virtual void DoRun (void);
 
 
 private:
+  bool m_txop; ///< true for non-null TXOP limit
   uint32_t m_received; ///< received packets
   uint16_t m_txTotal; ///< transmitted data packets
+  uint16_t m_txSinceBar; ///< packets transmitted since the agreement was established
+                         ///< or the last block ack was received
   uint16_t m_nBar; ///< transmitted BlockAckReq frames
   uint16_t m_nBa; ///< received BlockAck frames
 
@@ -679,10 +724,12 @@
     }
 }
 
-BlockAckAggregationDisabledTest::BlockAckAggregationDisabledTest ()
+BlockAckAggregationDisabledTest::BlockAckAggregationDisabledTest (bool txop)
   : TestCase ("Test case for Block Ack Policy with aggregation disabled"),
+    m_txop (txop),
     m_received (0),
     m_txTotal (0),
+    m_txSinceBar (0),
     m_nBar (0),
     m_nBa (0)
 {
@@ -707,13 +754,35 @@
   WifiMacHeader hdr;
   p->PeekHeader (hdr);
 
+  if (m_txSinceBar == 9 || m_txTotal == 14)
+    {
+      NS_TEST_ASSERT_MSG_EQ (hdr.IsBlockAckReq (), true, "Didn't get a BlockAckReq when expected");
+    }
+  else
+    {
+      NS_TEST_ASSERT_MSG_EQ (hdr.IsBlockAckReq (), false, "Got a BlockAckReq when not expected");
+    }
+
   if (hdr.IsQosData ())
     {
       m_txTotal++;
-      NS_TEST_EXPECT_MSG_EQ ((m_txTotal == 1 || hdr.IsQosBlockAck ()), true, "Unexpected QoS ack policy");
+      if (hdr.IsQosBlockAck ())
+        {
+          m_txSinceBar++;
+        }
+
+      if (!m_txop)
+        {
+          NS_TEST_EXPECT_MSG_EQ ((m_txTotal == 1 || hdr.IsQosBlockAck ()), true, "Unexpected QoS ack policy");
+        }
+      else
+        {
+          NS_TEST_EXPECT_MSG_EQ ((m_txTotal <= 2 || hdr.IsQosBlockAck ()), true, "Unexpected QoS ack policy");
+        }
     }
   else if (hdr.IsBlockAckReq ())
     {
+      m_txSinceBar = 0;
       m_nBar++;
     }
 }
@@ -745,6 +814,8 @@
 
   WifiHelper wifi;
   wifi.SetStandard (WIFI_PHY_STANDARD_80211a);
+  wifi.SetAckPolicySelectorForAc (AC_BE, "ns3::ConstantWifiAckPolicySelector",
+                                  "BaThreshold", DoubleValue (0.125));
   wifi.SetRemoteStationManager ("ns3::IdealWifiManager");
 
   WifiMacHelper mac;
@@ -785,6 +856,19 @@
   sta_device->GetMac ()->SetAttribute ("BE_MaxAmpduSize", UintegerValue (0));
   TxopDurationTracer txopTracer;
 
+  if (m_txop)
+    {
+      PointerValue ptr;
+      sta_device->GetMac ()->GetAttribute ("BE_Txop", ptr);
+      ptr.Get<QosTxop> ()->TraceConnectWithoutContext ("TxopTrace", MakeCallback (&TxopDurationTracer::Trace, &txopTracer));
+
+      // set the TXOP limit on BE AC
+      Ptr<RegularWifiMac> ap_mac = DynamicCast<RegularWifiMac> (ap_device->GetMac ());
+      NS_ASSERT (ap_mac);
+      ap_mac->GetAttribute ("BE_Txop", ptr);
+      ptr.Get<QosTxop> ()->SetTxopLimit (MicroSeconds (4800));
+    }
+
   PacketSocketAddress socket;
   socket.SetSingleDevice (sta_device->GetIfIndex ());
   socket.SetPhysicalAddress (ap_device->GetAddress ());
@@ -795,14 +879,29 @@
   packetSocket.Install (wifiStaNode);
   packetSocket.Install (wifiApNode);
 
-  Ptr<PacketSocketClient> client = CreateObject<PacketSocketClient> ();
-  client->SetAttribute ("PacketSize", UintegerValue (1400));
-  client->SetAttribute ("MaxPackets", UintegerValue (14));
-  client->SetAttribute ("Interval", TimeValue (MicroSeconds (0)));
-  client->SetRemote (socket);
-  wifiStaNode.Get (0)->AddApplication (client);
-  client->SetStartTime (Seconds (1));
-  client->SetStopTime (Seconds (3.0));
+  // the first client application generates a single packet, which is sent
+  // with the normal ack policy because there are no other packets queued
+  Ptr<PacketSocketClient> client1 = CreateObject<PacketSocketClient> ();
+  client1->SetAttribute ("PacketSize", UintegerValue (1400));
+  client1->SetAttribute ("MaxPackets", UintegerValue (1));
+  client1->SetAttribute ("Interval", TimeValue (MicroSeconds (0)));
+  client1->SetRemote (socket);
+  wifiStaNode.Get (0)->AddApplication (client1);
+  client1->SetStartTime (Seconds (1));
+  client1->SetStopTime (Seconds (3.0));
+
+  // the second client application generates 13 packets. Even if when the first
+  // packet is queued the queue is empty, the first packet is not transmitted
+  // immediately, but the EDCAF waits for the next slot boundary. At that time,
+  // other packets have been queued, hence a BA agreement is established first.
+  Ptr<PacketSocketClient> client2 = CreateObject<PacketSocketClient> ();
+  client2->SetAttribute ("PacketSize", UintegerValue (1400));
+  client2->SetAttribute ("MaxPackets", UintegerValue (13));
+  client2->SetAttribute ("Interval", TimeValue (MicroSeconds (0)));
+  client2->SetRemote (socket);
+  wifiStaNode.Get (0)->AddApplication (client2);
+  client2->SetStartTime (Seconds (1.5));
+  client2->SetStopTime (Seconds (3.0));
 
   Ptr<PacketSocketServer> server = CreateObject<PacketSocketServer> ();
   server->SetLocal (socket);
@@ -819,14 +918,18 @@
 
   Simulator::Destroy ();
 
-  // The client application generates 14 packets, so we expect that the wifi PHY
+  // The client applications generate 14 packets, so we expect that the wifi PHY
   // layer transmits 14 MPDUs, the server application receives 14 packets, and
-  // a BAR is transmitted after each MPDU but the first one (because a BA agreement
-  // is established before transmitting the second MPDU).
+  // two BARs are transmitted.
   NS_TEST_EXPECT_MSG_EQ (m_txTotal, 14, "Unexpected number of transmitted packets");
   NS_TEST_EXPECT_MSG_EQ (m_received, 14, "Unexpected number of received packets");
-  NS_TEST_EXPECT_MSG_EQ (m_nBar, 13, "Unexpected number of Block Ack Requests");
-  NS_TEST_EXPECT_MSG_EQ (m_nBa, 13, "Unexpected number of Block Ack Responses");
+  NS_TEST_EXPECT_MSG_EQ (m_nBar, 2, "Unexpected number of Block Ack Requests");
+  NS_TEST_EXPECT_MSG_EQ (m_nBa, 2, "Unexpected number of Block Ack Responses");
+  if (m_txop)
+    {
+      NS_TEST_EXPECT_MSG_LT (txopTracer.m_max, MicroSeconds (4800), "TXOP duration exceeded!");
+      NS_TEST_EXPECT_MSG_GT (txopTracer.m_max, MicroSeconds (3008), "The maximum TXOP duration is too short!");
+    }
 }
 
 /**
@@ -848,7 +951,8 @@
   AddTestCase (new PacketBufferingCaseB, TestCase::QUICK);
   AddTestCase (new OriginatorBlockAckWindowTest, TestCase::QUICK);
   AddTestCase (new CtrlBAckResponseHeaderTest, TestCase::QUICK);
-  AddTestCase (new BlockAckAggregationDisabledTest, TestCase::QUICK);
+  AddTestCase (new BlockAckAggregationDisabledTest (false), TestCase::QUICK);
+  AddTestCase (new BlockAckAggregationDisabledTest (true), TestCase::QUICK);
 }
 
 static BlockAckTestSuite g_blockAckTestSuite; ///< the test suite
